#!/usr/bin/env python
# -*- coding: utf-8 -*-

import readline
from array import array
readline.set_history_length(32)

font_base=0x788c
font_size=0x0400
font2_base=0x7c8c
font2_size=0x0080

bg_base=0x8000
bg_size=0x0c00
bg_cnt=10

with open("../../SuperLaydock.rom","rb") as f:
  d=f.read()

while True:
  s=raw_input()
  if s[0]=="q":
    break
  s=s.split()
  adr=int(s[0]) * bg_size + bg_base
  for i in [(int(i,16)-64) for i in s[1:]]:
    a=adr+i*16
    print "%04x"%(i*8)
    print "db\t", ",".join(["#%02x"%(j) for j in array("B",d[a  :a+ 8])])
    print "db\t", ",".join(["#%02x"%(j) for j in array("B",d[a+8:a+16])])
