;===============================================================
;
;	Super Laydock
;
;		ロゴがキラリ
;
;===============================================================
proc
		ld		a,(#e382)
		and		#03
		ret		nz

		; y座標移動
		ld		hl,#e3c1
		ld		a,(hl)
		inc		l
		ld		(hl),a
		ld		l,#c0
		ld		a,(hl)
		inc		l
		ld		(hl),a
		ld		l,#bf
		ld		a,(hl)
		inc		l
		ld		(hl),a

		ex		af,af'
		ld		a,(#e381)
		cp		#13
		ret		nc
		ex		af,af'

		; 消す側
		ld		l,#a1		;l:色 a:アドレス
		call	_wrt

		; 光る側
		ex		af,af'
		cp		#10
		jr		nc,_end
		ld		(#e3bf),a	;アドレス
		ld		l,#f1		;色
		call	_wrt
	_end:
		ld		hl,#8e00
		di
		out		(c),l
		ei
		out		(c),h
		ret

		; 書く
	_wrt:
		and		#0f
		add		a,#48		; 下位アドレス
		ld		c,#99
		ld		d,4			; 最上位アドレス
		di
	_lpD:
		out		(c),d
		ld		b,#8e
		out		(c),b
		ld		h,#38		; 上位アドレス+#40
		ld		e,2
	_lpE:
		ld		b,6
	_lp:
		out		(c),a
		out		(c),h
		dec		c
		add		a,#40		; 次の文字アドレスへ
		out		(c),l
		jr		nc,_sk
		inc		h			; 次の上位文字アドレスへ
	_sk:
		inc		c
		djnz	_lp
		sub		#80+1
		ld		h,#60
		dec		e
		jr		nz,_lpE
		inc		d
        bit		3,d
		jr		z,_lpD
		ei
		ret
endp
