;===============================================================
;
;	Super Laydock
;
;		ステージ1背景特殊処理
;
;===============================================================
proc
		call	_init

		ld		hl,#e3ab
		inc		(hl)
		ld		a,(hl)
		and		#f
		add		a,a
		ld		hl,_jptbl
		add		a,l
		ld		l,a
		ld		a,(hl)
		inc		l
		ld		h,(hl)
		ld		l,a
		call	call_hl

		ld		c,#99
		ld		hl,#8e00
		di
		out		(c),l
		ei
		out		(c),h
		ret

	_jptbl:
		dw		st1_d494,st1_d237,st1_d3c4_plus,st1_d3c4,st1_d4ee,st1_d364     ,st1_d51b,st1_d2cf
		dw		st1_d494,st1_d237,st1_d4c1     ,st1_d3c4,st1_d4ee,st1_d364_plus,st1_ret ,st1_d2cf

	_init:
		ld		a,#21
		ld		(#d200),a
		ld		a,(#e3ca)
		dec		a
		ret		z
		ld		hl,st1_ret
		ld		(_jptbl   ),hl
		ld		(_jptbl+ 8),hl
		ld		(_jptbl+12),hl
		ld		(_jptbl+16),hl
		ld		(_jptbl+20),hl
		ld		(_jptbl+24),hl
		ret
endp

st1_d35c:
		db		#00,#06,#08,#09,#09,#08,#06,#00	;,#00
st1_d3c0:
		db		#00,#0e,#0f,#0e	,#00



;=====================================-
;	戦艦、炎上1
;=====================================-
st1_d237:
proc
		ld		hl,#e3ae
		inc		(hl)
		ld		a,(hl)
		and		7
		ld		hl,st1_d35c
		add		a,l
		ld		l,a
		ld		e,(hl)
		inc		l
		ld		d,(hl)

		ld		a,#8e
		ex		af,af'

		ld		a,(cur_page)
		ld		l,a
		rrca
		and		3
		add		a,4
		ld		h,a

		ld		a,l
		rrca
		rrca
		and		#20
		add		a,#43

		ld		l,#6a
		ld		bc,#0299
	_lp_wrt:
		di
		out		(c),h
		ex		af,af'
		out		(c),a
		ex		af,af'

		rept	3
			out		(c),l
			out		(c),a
			dec		c
			out		(c),e
			add		a,8
			out		(c),d
			inc		c
		endm

		out		(c),l
		out		(c),a
		dec		c
		out		(c),e
		sub		24
		ei
		out		(c),d
		inc		c

		ld		l,#73
		ld		e,d
		djnz	_lp_wrt
endp
st1_ret:
		ret

;=====================================-
;	戦艦、炎上2
;=====================================-
st1_d2cf:
proc
		ld		hl,#e3ae
		inc		(hl)
		ld		a,(hl)
		and		7
		ld		hl,st1_d35c
		add		a,l
		ld		l,a
		ld		d,(hl)
		inc		l
		ld		e,(hl)

		ld		a,#8e
		ex		af,af'

		ld		a,(cur_page)
		ld		l,a
		rrca
		and		3
		add		a,4
		ld		h,a

		ld		a,l
		rrca
		rrca
		and		#20
		add		a,#43

		ld		l,#b0
		call	_wrt
		ld		l,#f2
		call	_wrt
		ld		e,d
		ld		l,#e7
	_wrt:
		ld		bc,#0499
	_lp_wrt:
		di
		out		(c),h
		ex		af,af'
		out		(c),a
		ex		af,af'

		rept	3
			out		(c),l
			out		(c),a
			dec		c
			out		(c),e
			add		a,8
			inc		c
		endm

		out		(c),l
		out		(c),a
		dec		c
		ei
		out		(c),e
		sub		24
		inc		c
		ret
endp
;=====================================-
;	戦艦、灯火
;=====================================-
st1_d3c4:
proc
		ld		hl,#e3ad
		inc		(hl)
		ld		a,(hl)
		and		7
		ld		hl,st1_d35c
		add		a,l
		ld		l,a
		ld		e,(hl)
		ld		d,#8e

		ld		a,(cur_page)
		ld		l,a
		rrca
		and		3
		add		a,4
		ld		h,a

		ld		a,l
		rrca
		rrca
		and		#20
		add		a,#45

		ld		l,#07
		call	_wrt
		ld		l,#3f
		call	_wrt
		inc		a
		ld		l,#cf
		call	_wrt
		ld		l,#f7
	_wrt:
		ld		bc,#0499
	_lp_wrt:
		di
		out		(c),h
		out		(c),d

		rept	3
			out		(c),l
			out		(c),a
			dec		c
			out		(c),e
			add		a,8
			inc		c
		endm

		out		(c),l
		out		(c),a
		dec		c
		ei
		out		(c),e
		sub		24
		inc		c
		ret
endp


;=====================================-
;	星、白1
;=====================================-
st1_d364:
proc
		ld		hl,#e3ac
		inc		(hl)
		ld		a,(hl)
		and		#3
		ld		hl,st1_d3c0
		add		a,l
		ld		l,a
		ld		e,(hl)
		ld		d,#0b
		jp		st1_star_anime
endp
;=====================================-
;	星、白2
;=====================================-
st1_d364_plus:
proc
		ld		a,(#e3ac)
		and		#3
		ld		hl,st1_d3c0
		add		a,l
		ld		l,a
		ld		e,(hl)
		ld		d,#4e
		jp		st1_star_anime
endp
;=====================================-
;	星、赤
;=====================================-
st1_d3c4_plus:
proc
		ld		a,(#e3ad)
		and		7
		ld		hl,st1_d35c
		add		a,l
		ld		l,a
		ld		e,(hl)
		ld		d,#74
;		jp		st1_star_anime
endp
st1_star_anime:
proc
		ld		hl,#8e04
		ld		bc,#0499
	_lp_page:
		di
		out		(c),l
		out		(c),h
		ld		a,#46
		rept	8
			out		(c),d
			out		(c),a
			dec		c
			out		(c),e
			inc		c
			add		a,8
		endm
		ei
		inc		l
		djnz	_lp_page
		ret
endp




;=====================================-
;	隕石0
;=====================================-
st1_d494:
proc
		ld		hl,_meteo
		ld		a,+(_meteo_end-_meteo)/2
		jp		st1_meteo_anime
		ret
	_meteo:
		dw	0xae54,0xaea3,0xaec7,0xaefb,0xaf09,0xaf2e,0xaf55,0xaf60,0xafa2,0xafac,0xaff8,0xb0ee,0xb205,0xb20e,0xb24a,0xb273,0xb2ab,0xb3a8,0xb4af
	_meteo_end:
endp
;=====================================-
;	隕石1
;=====================================-
st1_d4c1:
proc
		ld		hl,_meteo
		ld		a,+(_meteo_end-_meteo)/2
		jp		st1_meteo_anime
	_meteo:
		dw	0xadf1,0xae5e,0xae81,0xaf01,0xaf59,0xb091,0xb1c1,0xb200,0xb304,0xb3a1
	_meteo_end:
endp
;=====================================-
;	隕石2
;=====================================-
st1_d4ee:
proc
		ld		hl,_meteo
		ld		a,+(_meteo_end-_meteo)/2
		jp		st1_meteo_anime
	_meteo:
		dw	0xad55,0xae03,0xafaf,0xb06b
	_meteo_end:
endp
;=====================================-
;	隕石3
;=====================================-
st1_d51b:
proc
		ld		a,(#e3ca)
		dec		a
		jr		z,_do
		ld		a,#c9
		ld		(st1_meteo_anime),a
		ret
	_do:
		ld		hl,_meteo
		ld		a,+(_meteo_end-_meteo)/2
		jp		st1_meteo_anime
	_meteo:
		dw	0xae79,0xaf4e,0xb04c,0xb375
	_meteo_end:
endp
;=====================================-
;	隕石　共通
;=====================================-
st1_meteo_anime:
proc
		ld		(_core+1),hl
		ld		(_core+4),a

		ld		hl,(#e2e9)
		ld		a,#b4
		cp		h
		ret		c				;隕石圏未達
		ld		(_map_pos+1),hl
		ld		c,#f0
		call	_core

		ld		hl,(#e2e9)
		ld		de,-24
		add		hl,de
		ld		(_map_pos+1),hl
		ld		c,#f8

	_core:
		ld		hl,0
		ld		b,0
	_lp:
		ld		a,(hl)
		inc		hl
		push	hl
		ld		h,(hl)
		ld		l,a
		or		a
	_map_pos:
		ld		de,0
		sbc		hl,de
		jr		c,_next			;隕石圏未達
		ld		de,24*23
		sbc		hl,de
		jr		nc,_end			;これ以降スクロールアウト済み、終了
		ld		de,#e0a8+24*23-1
		add		hl,de

		ld		a,(hl)
		add		a,2
		and		#7
		or		c
		ld		(hl),a
		inc		hl
		ld		a,(hl)
		add		a,2
		and		#7
		or		c
		ld		(hl),a

	_next:
		pop		hl
		inc		hl
		djnz	_lp
		ret
	_end:
		pop		hl
		ret
endp
