;===============================================================
;
;	Super Laydock
;
;		ステージ7背景特殊処理
;
;===============================================================
macro	st07_nextdata, counter, cycle, data
		ld		hl,counter
		inc		(hl)
		ld		a,(hl)
		and		cycle
		ld		hl,data
		add		a,l
		ld		l,a
		ld		d,(hl)
endm

macro	st07_nextidx, counter, cycle
		ld		hl,counter
		inc		(hl)
		ld		a,(hl)
		and		cycle
endm

macro	st07_nextidx2, counter, cycle
		ld		hl,counter
		ld		a,(hl)
		inc		a
		cp		cycle
		jr		c,_under
		xor		a
	_under:
		ld		(hl),a
endm

macro	st07_nextidx3, counter, cycle
		ld		hl,counter
		ld		a,(hl)
		dec		a
		jp		p,_under
		ld		a,cycle -1
	_under:
		ld		(hl),a
endm


;=================================
;	入り口
;=================================
		st07_nextidx	#e3a7, 15
		cp		4
		jr		z,st07_d237
		cp		5
		jr		z,st07_d237_2
		and		7
		ret		nz

;====================================
;
;====================================
00d316:
		st07_nextdata	#e3a9, 3, st07_d312
		ld		c,#99

		ld		a,#06 | #40
		ld		e,#b5
		call	st07_anime1d;	a:上位アドレス e:下位アドレス d:出力値

		ld		a,#06 | #40
		ld		e,#bd
		call	st07_anime1d;	a:上位アドレス e:下位アドレス d:出力値

		jp		st07_end_vram16

;=================================
;
;=================================
st07_d312:
		db		#06,#08,#09,#08

;=================================
;
;=================================
st07_d237: 
		st07_nextdata	#e3a8, 3, st07_d312
		ld		c,#99

		ld		a,#04 | #40
		ld		e,#53
		call	st07_anime1;	a:上位アドレス e:下位アドレス d:出力値

		ld		a,#04 | #40
		ld		e,#5b
		call	st07_anime1;	a:上位アドレス e:下位アドレス d:出力値

		ld		a,#04 | #40
		ld		e,#63
		call	st07_anime1;	a:上位アドレス e:下位アドレス d:出力値

st07_end_vram16:
		ld		hl,#8e00
		ld		c,#99
		di
		out		(c),l
		ei
		out		(c),h
		ret

;=================================
;
;=================================
st07_d237_2:
		ld		a,(#e3a8)
		and		3
		ld		hl,st07_d312
		add		a,l
		ld		l,a
		ld		d,(hl)
		
		ld		c,#99

		ld		a,#04 | #40
		ld		e,#6b
		call	st07_anime1;	a:上位アドレス e:下位アドレス d:出力値

		ld		a,#04 | #40
		ld		e,#73
		call	st07_anime1;	a:上位アドレス e:下位アドレス d:出力値

		ld		a,#04 | #40
		ld		e,#7b
		call	st07_anime1;	a:上位アドレス e:下位アドレス d:出力値

		jp		st07_end_vram16



;===============================================================
;	a:上位アドレス e:下位アドレス d:出力値
;===============================================================
st07_anime1:
		macro	st07_anime1_outs
			out		(c),e
			out		(c),a
			dec		c
			add		a,8
			out		(c),d
			inc		c
	endm
proc
		ld		hl,#8e04
		ld		bc,#0499
	_lp_page:
		di
		out		(c),l
		out		(c),h
		rept	3
			st07_anime1_outs
		endm
		add		a,8
		rept	3
			st07_anime1_outs
		endm
		ei
		sub		8*7
		inc		l
		djnz	_lp_page
		ret
endp
;===============================================================
;	a:上位アドレス e:下位アドレス d:出力値
;===============================================================
st07_anime1d:
		macro	st07_anime1d_outs
			out		(c),e
			out		(c),a
			dec		c
			out		(c),d
			add		a,8
			out		(c),d
			inc		c
	endm
proc
		ld		hl,#8e04
		ld		bc,#0499
	_lp_page:
		di
		out		(c),l
		out		(c),h
		rept	3
			st07_anime1d_outs
		endm
		add		a,8
		rept	3
			st07_anime1d_outs
		endm
		ei
		sub		8*7
		inc		l
		djnz	_lp_page
		ret
endp
