;===============================================================
;
;	Super Laydock
;
;		ステージ11背景特殊処理
;
;===============================================================
macro	st11_getptr,	counter, data
		ld		a,(counter)
		ld		hl,data
		add		a,l
		ld		l,a
endm
macro	st11_nextidx,	counter, cycle
		ld		hl,counter
		ld		a,(hl)
		inc		a
		and		cycle
		ld		(hl),a
endm
macro	st11_nextdata,	counter, cycle, data
		st11_nextidx	counter, cycle
		ld		hl,data
		add		a,l
		ld		l,a
		ld		d,(hl)
endm


;=================================
;	入り口
;=================================
proc
		st11_nextidx	#e3a7, 0x1f
		bit		0,a
		jr		nz,_odd
		ld		hl,st11_d216
		add		a,l
		ld		l,a
		ld		a,(hl)
		inc		l
		ld		h,(hl)
		ld		l,a
		jp		(hl)
	_odd:
		and		6
		cp		6
		jp		z,st11_d257
		ret
endp

st11_d216:
		dw	st11_d2e9
		dw	st11_d31e
		dw	st11_d34c
		dw	st11_d444_b0
		dw	st11_d444_b1
		dw	st11_d444_b2
		dw	st11_ret
		dw	st11_ret
		dw	st11_d37a
		dw	st11_d3a8
		dw	st11_d3d6
		dw	st11_ret
		dw	st11_ret
		dw	st11_ret
		dw	st11_ret
		dw	st11_ret

st11_d2a8:
		db	#00,#60,#80,#90,#90,#80,#60,#00

st11_d2b0:
		db	#50,#56,#58,#59,#59,#58,#56,#50

st11_d404:
		db	#00,#01,#0e,#1f,#1e,#15,#6a,#f1,#00,#c0,#a0,#5c,#0d,#5c,#e5,#c2
		db	#f2,#ad,#4e,#0a,#75,#28,#1a,#01,#a0,#42,#09,#12,#25,#0a,#a0,#40
		db	#00,#00,#03,#06,#18,#32,#27,#16,#00,#00,#00,#60,#e0,#d0,#20,#0c
		db	#02,#28,#6c,#44,#31,#02,#01,#00,#1c,#4a,#e4,#40,#04,#a8,#40,#00

st11_d4c6:
		db	#82,#c3,#67,#3e,#14,#f8,#50,#28,#03,#7e,#d4,#80,#03,#0e,#7c,#d0
		db	#63,#ce,#9a,#28,#63,#46,#e4,#86,#8c,#87,#02,#00,#f0,#bc,#16,#03
		db	#e3,#79,#1b,#4e,#fe,#a4,#34,#62,#03,#86,#9c,#f4,#d1,#07,#0e,#78
		db	#c7,#9d,#14,#30,#21,#33,#63,#c6,#f0,#5b,#0e,#f0,#bc,#16,#06,#03

;=======================================
st11_d257:
		st11_nextdata	#e3a9, 7, st11_d2a8

		ld		a,#04 | #40
		ld		e,#02
		ld		h,#02
		call	st11_anime2;	a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数

		ld		a,#04 | #40
		ld		e,#06
		call	st11_anime2;	a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数

		ld		a,#04 | #40
		ld		e,#0a
		call	st11_anime2;	a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数

		ld		a,#04 | #40
		ld		e,#0e
		call	st11_anime2;	a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数

		ld		a,#04 | #40
		ld		e,#5e
		call	st11_anime1;	a:上位アドレス e:下位アドレス d:出力値

		st11_getptr	#e3a9, st11_d2b0
		ld		d,(hl)

		ld		a,#05 | #40
		ld		e,#b1
		call	st11_anime1;	a:上位アドレス e:下位アドレス d:出力値

		ld		a,#05 | #40
		ld		e,#79
		call	st11_anime1;	a:上位アドレス e:下位アドレス d:出力値

		ld		a,#05 | #40
		ld		e,#7b
		call	st11_anime1;	a:上位アドレス e:下位アドレス d:出力値

		jp		st11_end_vram16

;=======================================
st11_d2e9:
		ld		hl,#e3a8
		ld		a,(hl)
		add		a,#20
		and		#20
		ld		(hl),a
		ld		hl,st11_d404
		add		a,l
		ld		l,a
		ld		de,#4380
		jp		st11_write
;=======================================
st11_d31e:
		st11_getptr	#e3a8, st11_d404
		ld		de,#4b80
		jp		st11_write
;=======================================
st11_d34c:
		st11_getptr	#e3a8, st11_d404
		ld		de,#5380
		jp		st11_write
;=======================================
st11_d37a:
		st11_getptr	#e3a8, st11_d404
		ld		de,#43a0
		jp		st11_write
;=======================================
st11_d3a8:
		st11_getptr	#e3a8, st11_d404
		ld		de,#4ba0
		jp		st11_write
;=======================================
st11_d3d6:
		st11_getptr	#e3a8, st11_d404
		ld		de,#53a0
		jp		st11_write
;=======================================
st11_d444_b0:
		st11_getptr	#e3a8, st11_d4c6
		ld		de,#4320
		jp		st11_write
;=======================================
st11_d444_b1:
		st11_getptr	#e3a8, st11_d4c6
		ld		de,#4b20
		jp		st11_write
;=======================================
st11_d444_b2:
		st11_getptr	#e3a8, st11_d4c6
		ld		de,#5320
		jp		st11_write


;===============================================================
;	PCG2x2書き込み	hl:データ de:or40済みオフセットアドレス
;===============================================================
st11_write:
proc
		ld		bc,#0899
	_lp:
		ld		a,b
		rrca
		and		3
		di
		out		(c),a
		ld		a,#8e
		out		(c),a

		out		(c),e
		out		(c),d
		ld		a,b
		ld		b,#10
		dec		c
		otir
		inc		c
		ld		b,a

		ld		a,e
		add		a,#40
		ld		e,a

		out		(c),e
		out		(c),d
		ld		a,b
		ld		b,#10
		dec		c
		otir
		ei
		inc		c
		ld		b,a

		ld		a,d
		xor		#20
		ld		d,a

		ld		a,e
		sub		#40
		ld		e,a

		ld		a,l
		sub		#20
		ld		l,a

		djnz	_lp
endp
st11_end_vram16:
		ld		hl,#8e00
		di
		out		(c),l
		ei
		out		(c),h
st11_ret:
		ret


;===============================================================
;	a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数
;===============================================================
		macro	st11_anime2_outs
			out		(c),e
			out		(c),a
			ld		b,h
			dec		c
		_lp:
			out		(c),d
			djnz	_lp
			inc		c
			add		a,8
		endm
st11_anime1:
		ld		h,1
st11_anime2:
		ld		l,#04		; 最上位アドレス 4→5→6→7
st11_anime2_lp:
		ld		bc,#0499	; ループカウンタ 4→3→2→1
proc
	_lp:
		push	bc
		ex		af,af'
		ld		a,#8e
		di
		out		(c),l
		out		(c),a
		ex		af,af'
		rept	3
			st11_anime2_outs
		endm
		add		a,8
		rept	3
			st11_anime2_outs
		endm
		ei
		sub		8*7
		inc		l
		pop		bc
		djnz	_lp
		ret
endp
