;===============================================================
;
;	Super Laydock
;
;		PCG1文字書き換え a:番号 hl:データ[pcg:8,col:8]
;
;===============================================================
write_a_pcg:
proc
		ex		de,hl
		ld		h,8
		ld		l,a
		add		hl,hl
		add		hl,hl
		add		hl,hl
		ex		de,hl

		push	hl
		ld		bc,8
		add		hl,bc
		ld		bc,#0404
		call	_lp_page
		pop		hl
		ld		bc,#0300
		call	_lp_page

		; 1,2ページの4ブロック目は飛ばす
		ld		c,#99
		di
		ld		a,#8e
		out		(c),b
		out		(c),a

		ld		a,d
	_lp_last_st:
		ld		d,3
	_lp_last:
		out		(c),e
		out		(c),a
		dec		c
		ld		b,#8
		add		a,b
		push	hl
		otir
		pop		hl
		inc		c
		dec		d
		jr		nz,_lp_last
		add		a,8
		cp		#80
		jr		c,_lp_last_st
	_end:
		ei
		ret

		; 通常の書き込み
	_lp_page:
		push	bc

		ld		a,b
		or		c
		ld		bc,#8e99
		di
		out		(c),a
		out		(c),b

		ld		a,d
	_lp_block:
		out		(c),e
		out		(c),a
		dec		c
		ld		b,#8
		add		a,b
		push	hl
		otir
		pop		hl
		inc		c

		cp		#80
		jr		c,_lp_block
		ei

		pop		bc
		djnz	_lp_page
		ret
endp
