#!/bin/bash

pasmo --alocal slss.asm SuperLaydock-ss-v0.0.rom slss.symbol
if [ $? != 0 ] ; then
  read
  exit 1
fi

pasmo -E SuperLaydock_bv --alocal slss.asm SuperLaydock-bss-v0.0.rom slss-bv.symbol
if [ $? != 0 ] ; then
  read
  exit 1
fi

python3 -m ips_util create -o ../SuperLaydock-ss-v0.0.ips  ../../SuperLaydock.rom    SuperLaydock-ss-v0.0.rom
python3 -m ips_util create -o ../SuperLaydock-bss-v0.0.ips ../../SuperLaydock-bv.rom SuperLaydock-bss-v0.0.rom
