#!/usr/bin/env python
# -*- coding: utf-8 -*-

import subprocess
from array import array

font_base=0x788c
font_size=0x0400
font2_base=0x7c8c
font2_size=0x0080

bg_base=0x8000
bg_size=0x0c00
bg_cnt=10

def wrt(fn,d,adr,size,idx):
  p,c="",""
  for j in range(adr,adr+size,16):
    p+=d[j  :j+ 8]
    c+=d[j+8:j+16]
  if idx==2:	#stage 4
    st,ed=0x00c0,0x00c0+0x20
    p=p[:st]+"\x00\x0c\xa4\xc4\x62\x39\x09\x25\x00\x30\x25\x23\x46\x9c\x90\xa4\x25\x09\x39\x62\xc4\xa4\x2c\x08\xa4\x90\x9c\x46\x23\x25\x34\x10"+p[ed:]
    c=c[:st]+"\x60"*32+c[ed:]
    st,ed=0x04c0,0x04c0+0x20
    p=p[:st]+"\x00\x2c\xce\xe6\xf7\x7b\x3b\x4d\x00\x34\x73\x67\xef\xde\xdc\xb2\x4d\x3b\x7b\xf7\xe6\xce\x2c\x1c\xb2\xdc\xde\xef\x67\x76\x34\x38"+p[ed:]
    c=c[:st]+"\x60"*32+c[ed:]
  if idx==5:	#stage 8
    st,ed=0x0510,0x0510+0x20
    p=p[:st]+"\xe7\xac\xb0\xe0\xf3\xe3\xe7\x80\xe7\x75\x1d\x0f\x04\x04\x02\x02\x80\x80\xff\xff\xe0\xb0\xac\xe7\x0e\x02\x1e\x04\x0f\x1d\x75\xe7"+p[ed:]
    c=c[:st]+"\x06\x02\x02\x02\x2f\x2f\x2f\x02\x02\x02\x02\x02\x02\x02\x02\x02\x02\x02\x20\x20\x02\x0c\x0c\x0c\xc2\x02\xc2\x02\x0c\x0c\x0c\x0c"+c[ed:]
    #p=p[:st]+"\xf7\xcb\xe5\xf2\xf9\xbf\xaf\x8b\xef\xd3\xa7\x4f\x9f\xfd\xf5\xd1\x7f\xff\xf3\xe3\xe7\xcf\xcf\xff\xfe\xef\xff\xfb\xfd\xfb\xf5\xfb"+p[ed:]
    #c=c[:st]+"\x0e\x0e\x0e\x0e\x0e\x0e\x0e\x0e\x0e\x0e\x0e\x0e\x0e\x0e\x0e\x0e\x09\x00\x0f\x0f\x0f\x06\x08\x00\x08\x0e\x00\x0e\x0e\x0e\x0e\x0e"+c[ed:]
  subprocess.Popen(["../../../../lzsa-1.4.1/lzsa","-f1","-r","/dev/stdin",fn],stdin=subprocess.PIPE).communicate(p+c)

with open("../../SuperLaydock.rom","rb") as f:
  d=f.read()
  for i in range(bg_cnt):
    bg_adr=i * bg_size + bg_base
    wrt("slss-pcg_%02d.lzsa1r"%(i), d, bg_adr, bg_size, i)
  wrt("slss-font1.lzsa1r", d, font_base, font_size,0)
  d2=d[font_base:font_base+font_size-font2_size]+d[font2_base:font2_base+font2_size]
  wrt("slss-font2.lzsa1r", d2, 0, font_size,0)
