#!/usr/bin/env python
# -*- coding: utf-8 -*-

import subprocess
from array import array

def getpcg(d,st,ln):
  p,c="",""
  for i in range(st,st+ln*8*2,16):
    p+=d[i  :i+ 8]
    c+=d[i+8:i+16]
  p=array('B',p)
  c=array('B',c)
  for j,k in enumerate(c):
    if (k & 0xf0)==0x10:
      p[j]^=0xff
      c[j]=((k&0xf0)>>4)|((k&0x0f)<<4)
  return p.tostring(),c.tostring()

with open("../../SuperLaydock.rom","rb") as f:
  d=f.read()
  p0,c0=getpcg(d,0x788c,64)
  p1,c1=getpcg(d,0x7c8c,8)
  pcg=p0+"0"*(192*8)+p0[:0x38*8]+p1
  col=c0+"0"*(192*8)+c0[:0x38*8]+c1

src=[]
for s in [
"28 2e  32 33  2e 2e  2e 29",
"2f 34  35 36  37 38  39 2c",
"2f 3a  3b 3c  3d 3e  3f 2c",
"2d 2e  2e 2e  32 33  2e 30",
"2f 1c  0c 18  1b 0e  26 31",
"2f 00  00 00  00 00  00 2c",
"2f 1c  0c 18  1b 0e  27 2c",
"2f 00  00 00  00 00  00 30",
"2d 32  33 2e  2e 2e  32 31",
],[
"2d 32  33 2e  2e 2e  32 30",
"2f 18  19 1d  12 18  17 31",
"2f 0a  0a 0a  0a 0a  0a 2c",
"2c 2e  2e 2e  32 33  2e 2c",
"2c 24 139 24 13b 24 13d 2c",
"0a 24 139 24 13b 24 13d 0a",
"0a 24 139 24 13b 0d 13d 0a",
"0a 00 139 24 13b 18 13d 0a",
"0a 00 139 24 13b 0c 13b 0a",
],[
"2c 24 139 24 13b 0c 13b 2c",
"2c 24 139 24 13b 14 13b 2c",
"2c 24 139 24 13b 12 13b 30",
"2c 24 139 24 13b 17 13b 31",
"2c 26 139 27 13b 10 13b 2c",
"2c 32  33 2e  2e 2e  2e 2c",
"2f 1c  11 12  0e 15  0d 2c",
"29 2c  2c 30  31 2c  2c 2b",
"2f 24  24 24  24 0c  24 2c",
],[
"2f 24  24 24  24 0c  24 2c",
"2f 24  24 24  24 14  24 2c",
"2f 24  24 24  24 12  24 30",
"2f 24  24 24  24 17  24 31",
"2f 26  24 27  24 10  24 2c",
"2d 32  33 2e  2e 2e  2e 2c",
"2f 1c  11 12  0e 15  0d 2c",
"29 2c  2c 30  31 2c  2c 2b",
"28 2e  32 33  2e 2e  2e 29"]:
  s=[int(j,16)*8 for i in s for j in i.split()]
  s=[s[j] for i in range(8) for j in range(i,len(s),8)]
  p="".join([ pcg[i:i+8] for i in s])
  c="".join([ col[i:i+8] for i in s])
  src.append([p,c])

dat="".join([j[i] for i in [0,1] for j in src])
#dat=dat[:2*9*8]+"\x00"+dat[2*9*8+1:]	# 微調整^^;
#dat=dat[:3*9*8]+"\x00"+dat[3*9*8+1:]	# 微調整^^;

fn="slss-pcg_status.lzsa1r"
lzsa=["../../../../lzsa-1.4.1/lzsa","-f1","-r","/dev/stdin",fn]
subprocess.Popen(lzsa,stdin=subprocess.PIPE).communicate(dat)

from array import array
with open("ck.sc2","wb") as f:
  f.write("\xfe\x00\x00\x00\x38\x00\x00")
  for j in src: f.write(j[0])
  f.write("\x00"*(0x1800-len(src[0][0])*4))
  f.write(array("B",[i for j in range(3) for i in range(256)]).tostring())
  f.write("\x00"*0x500)
  for j in src: f.write(j[1])
  f.write("\x00"*(0x1800-len(src[0][0])*4))
  f.flush()
