;===============================================================
;
;	Super Laydock
;
;		ステージ14 セットアップ
;
;===============================================================
proc
		; ステージ14
		ld		a,#0e
		ld		(#e3ca),a
		; ステージ巻き戻し
		ld		a,#64
		ld		(#e4b9),a
		ld		hl,#bf7f
		ld		(#e2e9),hl
		ld		hl,#0120
		ld		(#e379),hl
		ld		hl,#bf80
		ld		a,(hl)
		add		a,#17
		ld		(#e376),a
		ld		(#e377),hl

		; 単一色で塗りつぶし
		ld		de,#0300 | #4000
		ld		hl,#20d0
		call	fill_col_allpages
		ld		e,#40
		call	fill_col_allpages
		ld		e,#20
		call	fill_col_allpages
		ld		e,#60
		call	fill_col_allpages

		; ソースで色更新
		ld		a,#0c
		di
		ld		(#7000),a

		ld		b,#04
	_lp_page:
		ld		de,#0380 | #4000
		push	bc

		ld		a,b
		or		4
		ld		b,#8e
		out		(c),a
		out		(c),b

	_lp_block:
		out		(c),e
		out		(c),d
		dec		c
		ld		hl,#9ed0
		ld		b,#40
		otir
		inc		c

		ld		a,d
		add		a,8
		ld		d,a
		cp		#80
		jr		c,_lp_block

		pop		bc
		djnz	_lp_page

		ld		a,#02
		ld		(#7000),a
		ei

		jp		st12_end_vram16
endp
