;===============================================================
;
;	Super Laydock
;
;		フェードアウト処理
;
;===============================================================
proc
		ld		a,(#e337)
		or		a
		ret		nz

		ld		hl,disp_flag
		set		7,(hl)

		; 消去対象のラインを移動/保持
		ld		hl,#e3e7
		inc		(hl)
		ld		a,(hl)
		ld		e,a

		; 対象のページを取得
		ld		a,(cur_page)
		ld		hl,#4200
		srl		a
		jr		nc,_odd_page
		ld		h,#62
	_odd_page:
		add		a,#04
		ld		d,a

		; 消す
		ld		bc,#499
	_lp_block:
		push	bc
		ld		b,#c0

		di
	_lp:
		ld		a,e
		add		a,5
		and		7
		ld		e,a
		add		a,l
		ld		l,a
		out		(c),d
		ld		a,#8e
		out		(c),a
		out		(c),l
		out		(c),h
		dec		c
		xor		a
		out		(c),a
		inc		c
		ld		a,l
		sub		e
		add		a,#8
		ld		l,a
		jr		nc,_nc
		inc		h
	_nc:
		djnz	_lp
		ei

		inc		h
		inc		h
		pop		bc
		djnz	_lp_block


		; カウンタ[e3e6]--
		ld		hl,#e3e6
		dec		(hl)
		ret		nz

		;call	#0041
		;ld		ix,clear_vram_all
		;call	call_bank_pcg_font

		ld		hl,disp_flag
		res		7,(hl)
		ret
endp
