;===============================================================
;
;	Super Laydock
;
;		スコア更新/表示
;
;===============================================================
macro	update_score_pX,	shield, score, dest
		ld		a,(shield)
		or		a
		ret		z

		push	hl
		push	de
		push	bc

		;スコア加算
		ld		hl,score
		ld		b,2
		ld		c,d
		ld		de,dest		; 書き込み先アドレス
		ld		ix,write_score
	_add_lp:
		ld		a,(hl)
		add		a,c
		daa
		ld		(hl),a
		jr		nc,_call
		ld		de,dest-#80		; 書き込み先アドレス
		ld		c,1
		dec		l
		djnz	_add_lp
		inc		(hl)
		ld		de,dest-#c0		; 書き込み先アドレス(1桁
		ld		ix,write_score2
	_call:
		call	call_bank_pcg_font
		pop		bc
		pop		de
		pop		hl
		ret
endm


;===============================================================
;	スコア更新/表示 player1
;===============================================================
; score: e388,0 e389,1 e38a,2
update_score_p1:
proc
		update_score_pX	#e2f3, #e38a, #6120
endp


filler	#8427
;===============================================================
;	スコア更新/表示 player2
;===============================================================
; score: e38b,0 e38c,1 e38d,2
update_score_p2:
proc
		update_score_pX	#e2fb, #e38d, #6130
endp
