;===============================================================
;
;	Super Laydock
;
;		ステージ5背景特殊処理
;
;===============================================================
macro	st05_nextdata, counter, cycle, data
		ld		hl,counter
		inc		(hl)
		ld		a,(hl)
		and		cycle
		ld		hl,data
		add		a,l
		ld		l,a
		ld		d,(hl)
endm

macro	st05_nextidx, counter, cycle
		ld		hl,counter
		inc		(hl)
		ld		a,(hl)
		and		cycle
endm

macro	st05_nextidx2, counter, cycle
		ld		hl,counter
		ld		a,(hl)
		inc		a
		cp		cycle
		jr		c,_under
		xor		a
	_under:
		ld		(hl),a
endm

macro	st05_nextidx3, counter, cycle
		ld		hl,counter
		ld		a,(hl)
		dec		a
		jp		p,_under
		ld		a,cycle -1
	_under:
		ld		(hl),a
endm


;=================================
;	入り口
;=================================
		call	st05_d3da_update
		call	st05_d4de_update

		st05_nextidx	#e3a7, 15
		add		a,a
		ld		hl,st05_d216
		add		a,l
		ld		l,a
		ld		a,(hl)
		inc		l
		ld		h,(hl)
		ld		l,a
		jp		(hl)

st05_d216:
		dw	st05_d4de, st05_d27d, st05_d360, st05_d3da
		dw	st05_ret , st05_d2f1, st05_ret , st05_ret  
		dw	st05_d237, st05_d27d, st05_ret , st05_d3da
		dw	st05_ret , st05_d2f1, st05_ret , st05_ret

st05_d279:
		db	#16,#18,#19,#18

st05_d2ed:
		db	#16,#18,#19,#18

st05_d3ba:
		db	#83,#c1,#83,#c1,#83,#c1,#83,#c1
		db	#83,#c1,#87,#81,#8f,#01,#87,#81
		db	#83,#c1,#83,#c1,#83,#c1,#83,#c1
		db	#83,#c1,#81,#e1,#80,#f1,#81,#e1

st05_d562:
		db	#cb,#6d,#a6,#cb,#6d,#a6,#cb,#6d,#a6,#cb,#6d
st05_d56d:
		db	#d3,#b6,#65,#d3,#b6,#65,#d3,#b6,#65,#d3,#b6
st05_d578:
		db	#0d,#a6,#06,#cb,#0b,#6d
st05_d57e:
		db	#b0,#65,#60,#d3,#d0,#b6
st05_d584:
		db	#42,#a8,#a4,#41,#a8,#a4,#42,#a8,#a4,#41,#a8
st05_d58f:
		db	#82,#15,#25,#82,#15,#25,#82,#15,#25,#82,#15


;=================================
;	1/16
;=================================
st05_d237:
		st05_nextdata	#e3a8, 3, st05_d279

		ld		a,#02 | #40
		ld		e,#09
		ld		h,#06
		call	st05_anime2;	a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数

		jp		st05_end_vram16

;=================================
;	1/8
;=================================
st05_d27d:
		st05_nextdata	#e3a9, 3, st05_d2ed

		ld		a,#03 | #40
		ld		e,#11
		ld		h,#02
		call	st05_anime2;	a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数

		ld		a,#03 | #40
		ld		e,#29
		ld		h,#02
		call	st05_anime2;	a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数

		jp		st05_end_vram16

;=================================
;	1/8
;=================================
st05_d2f1:
		st05_nextdata	#e3aa, 3, st05_d2ed

		ld		a,#07 | #40
		ld		e,#a5
		ld		h,#02
		call	st05_anime2;	a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数

		ld		a,#07 | #40
		ld		e,#ad
		ld		h,#02
		call	st05_anime2;	a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数

		jp		st05_end_vram16

;=================================
;	1/16
;=================================
st05_d360:
		st05_nextidx	#e3ab, 15
		ld		hl,st05_d3ba
		add		a,a
		add		a,l
		ld		l,a
		ld		d,(hl)
		inc		l
		ld		a,(hl)
		push	af

		ld		a,#04 | #40
		ld		e,#c3
		call	st05_anime1;	a:上位アドレス e:下位アドレス d:出力値

		pop		de

		ld		a,#04 | #40
		ld		e,#cb
		call	st05_anime1;	a:上位アドレス e:下位アドレス d:出力値

		jp		st05_end_vram16


;=================================
;	1/8		ボス絵フレーム遷移
;=================================
st05_d3da:
		st05_nextidx2	#e3ac,6
		st05_nextidx2	#e3ad,3

		; マップ終端なら、更新フラグセット
		ld		hl,(#e379) 
		ld		a,l
		or		h
		ret		nz
		ld		a,#ff
		ld		(st05_d3da_cur_page+1),a
		ret

;=================================
;	1/16	ボス絵フレーム遷移
;=================================
st05_d4de:
		st05_nextidx3	#e3ae,6

		; マップ終端なら、更新フラグセット
		ld		hl,(#e379) 
		ld		a,l
		or		h
		ret		nz
		ld		a,#ff
		ld		(st05_d4de_cur_page+1),a
		ret

;=================================
;	1/8		ボス絵更新
;=================================
st05_d3da_update:
		ld		a,(cur_page)
	st05_d3da_cur_page:
		cp		#ff				; 描画済みページ
		ret		z
		ld		(st05_d3da_cur_page+1),a

		; 対象ページ取得
		rrca
		ld		d,a
		rrca
		rrca
		and		#20		;偶数ページ
		or		#47		; 上位アドレス
		ld		e,a
		ld		a,d
		and		3
		ld		d,a		; 最上位アドレス

		ld		c,#99

		; 対象データ取得
		ld		a,(#e3ac)
		ld		hl,st05_d562
		add		a,l
		ld		l,a
		ld		b,6

		; 書き込み
		di
		out		(c),d
		ld		a,#8e
		out		(c),a
		ld		a,#50	; 下位アドレス
		out		(c),a
		out		(c),e
		dec		c
		otir
		ei
		inc		c

		; 対象データ取得
		ld		a,(#e3ac)
		ld		hl,st05_d56d
		add		a,l
		ld		l,a
		ld		b,6

		; 書き込み
		di
		out		(c),d
		ld		a,#8e
		out		(c),a
		ld		a,#68	; 下位アドレス
		out		(c),a
		out		(c),e
		dec		c
		otir
		ei
		inc		c

		; 対象データ取得
		ld		a,(#e3ac)
		add		a,a
		ld		hl,st05_d578
		add		a,l
		ld		l,a
		ld		b,2

		; 書き込み
		di
		out		(c),d
		ld		a,#8e
		out		(c),a
		ld		a,#16	; 下位アドレス
		out		(c),a
		out		(c),e
		dec		c
		otir
		ei
		inc		c

		; 対象データ取得
		ld		a,(#e3ad)
		add		a,a
		ld		hl,st05_d57e
		add		a,l
		ld		l,a
		ld		b,2

		; 書き込み
		di
		out		(c),d
		ld		a,#8e
		out		(c),a
		ld		a,#2e	; 下位アドレス
		out		(c),a
		out		(c),e
		dec		c
		otir
		ei
		inc		c

		; 最上位アドレス戻して終了
		jp		st05_end_vram16


;=================================
;	1/16		ボス絵更新
;=================================
st05_d4de_update:
		ld		a,(cur_page)
	st05_d4de_cur_page:
		cp		#ff				; 描画済みページ
		ret		z
		ld		(st05_d4de_cur_page+1),a

		;対象ページ取得
		rrca
		ld		d,a
		rrca
		rrca
		and		#20		;偶数ページ
		or		#47		; 上位アドレス
		ld		e,a
		ld		a,d
		and		3
		ld		d,a		; 最上位アドレス

		ld		c,#99

		; 対象データ取得
		ld		a,(#e3ae)
		ld		hl,st05_d584
		add		a,l
		ld		l,a
		ld		b,6

		; 書き込み
		di
		out		(c),d
		ld		a,#8e
		out		(c),a
		ld		a,#5a	; 下位アドレス
		out		(c),a
		out		(c),e
		dec		c
		otir
		ei
		inc		c

		; 対象データ取得
		ld		a,(#e3ae)
		ld		hl,st05_d58f
		add		a,l
		ld		l,a
		ld		b,6

		; 書き込み
		di
		out		(c),d
		ld		a,#8e
		out		(c),a
		ld		a,#62	; 下位アドレス
		out		(c),a
		out		(c),e
		dec		c
		otir
		ei
		inc		c

		; 最上位アドレス戻して終了
		jp		st05_end_vram16


;===============================================================
;	vram最上位アドレス戻す
;===============================================================
st05_end_vram16:
		ld		hl,#8e00
		ld		c,#99
		di
		out		(c),l
		ei
		out		(c),h
st05_ret:
		ret

;===============================================================
;	a:上位アドレス e:下位アドレス d:出力値
;===============================================================
st05_anime1:
		macro	st05_anime1_outs
			out		(c),e
			out		(c),a
			dec		c
			add		a,8
			out		(c),d
			inc		c
	endm
proc
		ld		hl,#8e00
		ld		bc,#0499
	_lp_page:
		di
		out		(c),l
		out		(c),h
		rept	3
			st05_anime1_outs
		endm
		add		a,8
		rept	3
			st05_anime1_outs
		endm
		ei
		sub		8*7
		inc		l
		djnz	_lp_page
		ret
endp
;===============================================================
;	a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数 l:最上位アドレス
;===============================================================
st05_anime2_2page:
		ld		bc,#0199
		jr		st05_anime2_lp
;===============================================================
;	a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数
;===============================================================
st05_anime2:
		macro	st05_anime2_outs
			out		(c),e
			out		(c),a
			ld		b,h
			dec		c
		_lp:
			out		(c),d
			djnz	_lp
			inc		c
			add		a,8
		endm

		ld		l,#04		; 最上位アドレス 4→5→6→7
		ld		bc,#0499	; ループカウンタ 4→3→2→1
st05_anime2_lp:
proc
	_lp:
		push	bc
		ex		af,af'
		ld		a,#8e
		di
		out		(c),l
		out		(c),a
		ex		af,af'
		rept	3
			st05_anime2_outs
		endm
		add		a,8
		rept	3
			st05_anime2_outs
		endm
		ei
		sub		8*7
		inc		l
		pop		bc
		djnz	_lp
		ret
endp
