;===============================================================
;
;	Super Laydock
;
;		ステージ8背景特殊処理
;
;===============================================================
macro	st09_getdata,	data
		ld		hl,data
		add		a,l
		ld		l,a
		ld		d,(hl)
endm
macro	st09_nextidx,	counter, cycle
		ld		hl,counter
		inc		(hl)
		ld		a,(hl)
		and		cycle
endm
macro	st09_nextdata,	counter, cycle, data
		st09_nextidx	counter, cycle
		st09_getdata	data
endm


;=================================
;
;=================================
		st09_nextidx	#e3a7, 7
		ret		nz
		st09_nextdata	#e3a8, 7, st09_d319

		ld		hl,(#e379)
		ld		a,h
		or		a
		jr		nz,#d200
		ld		a,l
		cp		15
		jp		c,st09_d2e7


		ld		a,#06 | #40
		ld		e,#d9
		ld		h,#06
		call	st09_anime2	;	a:上位アドレス e:下位アドレス d:出力値

		ld		a,#06 | #40
		ld		e,#c4
		call	st09_anime1	;	a:上位アドレス e:下位アドレス d:出力値

		ld		a,#07 | #40
		ld		e,#4b
		call	st09_anime1	;	a:上位アドレス e:下位アドレス d:出力値

		ld		a,d
		or		#c0
		ld		d,a

		ld		a,#03 | #40
		ld		e,#9b
		call	st09_anime1	;	a:上位アドレス e:下位アドレス d:出力値

		ld		a,d
		add		a,a
		add		a,a
		add		a,a
		add		a,a
		or		12
		ld		d,a

		ld		a,#03 | #40
		ld		e,#e3
		call	st09_anime1	;	a:上位アドレス e:下位アドレス d:出力値

		;	vram最上位アドレス戻す
st09_end_vram16:
		ld		hl,#8e00
		ld		c,#99
		di
		out		(c),l
		ei
		out		(c),h
		ret

st09_d2e7:
		ld		a,#07 | #40
		ld		e,#09
		ld		h,#06
		call	st09_anime2	;	a:上位アドレス e:下位アドレス d:出力値
		jp		st09_end_vram16


st09_d319:
		db		#00,#06,#08,#09,#09,#08,#06,#00


;===============================================================
;	a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数
;===============================================================
		macro	st09_anime2_outs
			out		(c),e
			out		(c),a
			ld		b,h
			dec		c
		_lp:
			out		(c),d
			djnz	_lp
			inc		c
			add		a,8
		endm
st09_anime1:
		ld		h,1
st09_anime2:
		ld		l,#04		; 最上位アドレス 4→5→6→7
st09_anime2_lp:
		ld		bc,#0499	; ループカウンタ 4→3→2→1
proc
	_lp:
		push	bc
		ex		af,af'
		ld		a,#8e
		di
		out		(c),l
		out		(c),a
		ex		af,af'
		rept	3
			st09_anime2_outs
		endm
		add		a,8
		rept	3
			st09_anime2_outs
		endm
		ei
		sub		8*7
		inc		l
		pop		bc
		djnz	_lp
		ret
endp
